package main

import (
	"fmt"

	g "github.com/AllenDang/giu"
)

func loop() {
	g.SingleWindow("Container").Layout(
		g.Label("Below buttons are generated by RangeBuilder in one line"),
		g.Row(
			g.RangeBuilder("Buttons in one line", []interface{}{"Button1", "Button2", "Button3"}, func(i int, v interface{}) g.Widget {
				str := v.(string)
				return g.Layout{
					g.Button(str).OnClick(func() {
						fmt.Println(str, "is clicked", i)
					}),
					g.Tooltip("Tooltip for " + str),
				}
			})...,
		),
		g.Dummy(0, 8),
		g.Label("Below buttons are generated by RangeBuilder"),
		g.RangeBuilder("Buttons", []interface{}{"Button1", "Button2", "Button3"}, func(i int, v interface{}) g.Widget {
			str := v.(string)
			return g.Button(str).OnClick(func() {
				fmt.Println(str, "is clicked")
			})
		}),
	)
}

func main() {
	wnd := g.NewMasterWindow("Range builder demo", 800, 600, 0, nil)
	wnd.Run(loop)
}
